OpenTTD Source: AirportResolverObject Struct Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Data Fields
AirportResolverObject Struct Reference

Resolver object for airports. More...

`#include <newgrf_airport.h>`

Inheritance diagram for AirportResolverObject:

## Public Member Functions
| AirportResolverObject (TileIndex tile, Station *st, const AirportSpec *spec, uint8_t layout, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Constructor of the airport resolver.
TownScopeResolver * | GetTown ()
| Get the town scope associated with a station, if it exists.
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, uint8_t relative=0) override
| Get a resolver for the scope.
GrfSpecFeature | GetFeature () const override
| Get the feature number being resolved for.
uint32_t | GetDebugID () const override
| Get an identifier for the item being resolved.
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Resolver constructor.
ResolverResult | DoResolve ()
int32_t | GetRegister (uint i) const
| Gets the value of a so-called newgrf "register".
void | SetRegister (uint i, int32_t value)
| Sets the value of a so-called newgrf "register".
template<class TSpriteGroup >
const TSpriteGroup * | Resolve ()
| Resolve SpriteGroup.
void | ResolveRerandomisation ()
| Resolve bits to be rerandomised.
CallbackResult | ResolveCallback (std::span< int32_t > regs100)
| Resolve callback.
virtual const SpriteGroup * | ResolveReal (const RealSpriteGroup &group) const
| Get the real sprites of the grf.
uint32_t | GetWaitingRandomTriggers () const
| Used by RandomizedSpriteGroup: Triggers for rerandomisation.
void | AddUsedRandomTriggers (uint32_t triggers)
| Used by RandomizedSpriteGroup: Consume triggers.
uint32_t | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with.

## Data Fields
AirportScopeResolver | airport_scope
std::optional< TownScopeResolver > | town_scope = std::nullopt
| The town scope resolver (created on the first call).
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback {}
| Callback being resolved.
uint32_t | callback_param1 = 0
| First parameter (var 10) of the callback.
uint32_t | callback_param2 = 0
| Second parameter (var 18) of the callback.
uint32_t | last_value = 0
| Result of most recent DeterministicSpriteGroup (including procedure calls)
std::array< uint32_t, VSG_END > | reseed
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile = nullptr
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup = nullptr
| Root SpriteGroup to use for resolving.

## Additional Inherited Members
Protected Attributes inherited from ResolverObject
uint32_t | waiting_random_triggers = 0
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32_t | used_random_triggers = 0
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)

## Detailed Description

Resolver object for airports.

Definition at line 183 of file newgrf_airport.h.

## Constructor & Destructor Documentation

## ◆ AirportResolverObject()

AirportResolverObject::AirportResolverObject | ( | TileIndex | tile,
|  | Station * | st,
|  | const AirportSpec * | spec,
|  | uint8_t | layout,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32_t | param1 = `0`,
|  | uint32_t | param2 = `0`
| ) |  |

Constructor of the airport resolver.

Parameters

  tile | Tile for the callback, only valid for airporttile callbacks.
  st | Station of the airport for which the callback is run, or `nullptr` for build gui.
  spec | AirportSpec for which the callback is run.
  layout | Layout of the airport to build.
  callback | Callback ID.
  param1 | First parameter (var 10) of the callback.
  param2 | Second parameter (var 18) of the callback.

Definition at line 251 of file newgrf_airport.cpp.

References StandardGRFFileProps::GetSpriteGroup(), AirportSpec::grf_prop, and ResolverObject::root_spritegroup.

## Member Function Documentation

## ◆ GetDebugID()

uint32_t AirportResolverObject::GetDebugID | ( |  | ) | const
| overridevirtual

Get an identifier for the item being resolved.

This function is mainly intended for the callback profiling feature, and should return an identifier recognisable by the NewGRF developer.

Reimplemented from ResolverObject.

Definition at line 190 of file newgrf_airport.cpp.

References AirportSpec::grf_prop, GRFFilePropsBase::local_id, and AirportScopeResolver::spec.

## ◆ GetFeature()

GrfSpecFeature AirportResolverObject::GetFeature | ( |  | ) | const
| overridevirtual

Get the feature number being resolved for.

This function is mainly intended for the callback profiling feature.

Reimplemented from ResolverObject.

Definition at line 185 of file newgrf_airport.cpp.

## ◆ GetScope()

ScopeResolver * AirportResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | uint8_t | relative = `0`
| ) |  |
| inlineoverridevirtual

Get a resolver for the scope.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 192 of file newgrf_airport.h.

References ResolverObject::GetScope(), GetTown(), VSG_SCOPE_PARENT, and VSG_SCOPE_SELF.

Referenced by NIHAirport::Resolve().

## ◆ GetTown()

TownScopeResolver * AirportResolverObject::GetTown | ( |  | ) |

Get the town scope associated with a station, if it exists.

On the first call, the town scope is created (if possible).

Returns
  Town scope, if available.

Definition at line 226 of file newgrf_airport.cpp.

References ClosestTownFromTile(), INVALID_TILE, AirportScopeResolver::st, AirportScopeResolver::tile, BaseStation::town, and town_scope.

Referenced by GetScope().

## Field Documentation

## ◆ airport_scope

AirportScopeResolver AirportResolverObject::airport_scope

Definition at line 184 of file newgrf_airport.h.

## ◆ town_scope

std::optional<TownScopeResolver> AirportResolverObject::town_scope = std::nullopt

The town scope resolver (created on the first call).

Definition at line 185 of file newgrf_airport.h.

Referenced by GetTown().

The documentation for this struct was generated from the following files:

- src/newgrf_airport.h
- src/newgrf_airport.cpp